MultipleUrlLoader = Core.class(EventDispatcher)

function MultipleUrlLoader:init(urls)
	self.urls = {}
	for i=1,#urls do
		self.urls[i] = urls[i]
	end
	
	for i=1,3 do	-- load 3 images in parallel
		self:loadNext()
	end
end

function MultipleUrlLoader:loadNext()
	if #self.urls == 0 then
		return
	end
	
	local url = self.urls[1]
	table.remove(self.urls, 1)
	
	local loader = UrlLoader.new(url)
	loader:addEventListener(Event.COMPLETE, self.onComplete, {self, url})
	loader:addEventListener(Event.ERROR, self.onError, {self, url})
end

function MultipleUrlLoader.onComplete(data, event)
	local self = data[1]
	local url = data[2]
	
	local newEvent = Event.new(Event.COMPLETE)
	newEvent.data = event.data
	newEvent.url = url
	self:dispatchEvent(newEvent)
	
	self:loadNext()
end

function MultipleUrlLoader.onError(data, event)
	local self = data[1]
	local url = data[2]
	
	local newEvent = Event.new(Event.ERROR)
	newEvent.url = url
	self:dispatchEvent(newEvent)
	
	self:loadNext()
end